*********************
* In class demonstration for POLI574 Discrete Choice 
set more on

global folder "C:\Users\Fred Cutler\Documents\My Dropbox"

** Use 2011 CES data, Quebec only

use "$folder\574exercisedata.dta", clear

***************************************
****** MULTINOMIAL LOGIT **************
** No choice-specific indep. vars.*****
***************************************

mlogit vote sov spend_EN 

estsimp mlogit vote sov  spend_EN

setx mean

simqi, fd(pr) changex(spend_EN -1 1)
more
clear

***************************
**   Conditional Logit
***************************

** we must expand the dataset to allow conditional logit
** first save it as something else
save "$folder\574clogit.dta"

** create id variable for each respondent
gen id=_n
more

*create 5 identical 'cases' for each respondent
expand 6
more

*indicate these as 1-6 for each respondent
* For Liberal, Cons, NDP, BQ, Green, and DK/Refused
bysort id: gen alt = _n
more

* create dummy for each alternative
foreach i of num 1/6{
  gen alt_`i'=0
  replace alt_`i'=1 if alt==`i'
  }

more

* create choice variable as a dummy if that choice is chosen (vote intention)
gen choice=vote==alt
replace choice=1 if alt==6 & vote==.
label def ptychoice 1"Lib" 2"CPC" 3" NDP" 4"BQ" 5"Green" 6"DK Refused"
label val alt ptychoice
more

* one choice-specific variable
gen french=INTLANG==5
label def lang 1 "English" 5 "French"
label val INTLANG lang
recode INTLANG 2=1
gen samelang=0
more


* samelang eq 1 if French interview and BQ alternative
replace samelang=1 if INTL==5 & alt==4
replace samelang=1 if INTL==1 & alt~=4 & alt~=6
more

** have a look at the data 
list id alt INTLANG samelang vote choice in 1/18, sepby(id)
more

*** the asclogit command is "Alternative-Specific Conditional Logit"

** to do what Golder does in his section 3, pp 11-14 we have to specify noconstant
** this is strictly choice-specific influences
asclogit choice samelang, case(id)  alt(alt) noconstant
more

** or the old command, clogit, would be: clogit choice samelang, group(id)

** what does the coefficient mean? let's get it as an odds ratio instead of a logit
asclogit, or /* that estimation command without variables just redisplays the previous results */
more

** now lets add a variable on policy about corporate taxes
** assume NDP and BQ want higher corporate taxes, Libs and Green same, Consv less
genl dist_corptax=0
replace dist_corptax=tax_corp-(-1) if alt==2
replace dist_corptax=tax_corp-(-0) if alt==1 | alt==5
replace dist_corptax=tax_corp-(1) if alt==3 | alt==4
replace dist_corptax=abs(dist_corptax)
more

** let's do this with clogit so we can use mfx or margins to help us because Clarify can't

clogit choice samelang dist_corptax, group(id)
* now mfx with the pu0 option cuz it's the only one that works 
mfx, predict(pu0)
more


******** NOW a mixed model ***********

* easy with asclogit

asclogit choice samelang dist_corptax, case(id) casevars(female educ income) alt(alt) noconstant or

